commit 4c922e093738762734f2bffc4f863a49a9c36885
Author: awy <awy@awy.one>
Date: Sat, 1 Mar 2025 15:36:31 +0300
upload
Diffstat:
6 files changed, 401 insertions(+), 0 deletions(-)
diff --git a/README.md b/README.md
@@ -0,0 +1,4 @@
+Firefox Setup Automation Script
+===============================
+Basically just a fork from emrakyz's configure_librewolf.sh.
+https://github.com/emrakyz/automated-gentoo/blob/main/configure_librewolf.sh
diff --git a/configure_librewolf.sh b/configure_librewolf.sh
@@ -0,0 +1,240 @@
+#!/usr/bin/env bash
+
+set -Eeo pipefail
+
+[ "${UID}" = "0" ] && echo "Root not allowed" && exit
+
+G='\e[1;92m' R='\e[1;91m' B='\e[1;94m'
+P='\e[1;95m' Y='\e[1;93m' N='\033[0m'
+C='\e[1;96m' W='\e[1;97m'
+
+URL_USER_JS="https://raw.githubusercontent.com/arkenfox/user.js/master/user.js"
+URL_UPDATER_SH="https://raw.githubusercontent.com/arkenfox/user.js/master/updater.sh"
+URL_USER_OVERRIDES_JS="https://raw.githubusercontent.com/awnrt/automated-firefox/refs/heads/master/user-overrides.js"
+URL_USERCHROME_CSS="https://raw.githubusercontent.com/awnrt/automated-firefox/refs/heads/master/userChrome.css"
+URL_USERCONTENT_CSS="https://raw.githubusercontent.com/awnrt/automated-firefox/refs/heads/master/userContent.css"
+URL_UBLOCK_BACKUP="https://raw.githubusercontent.com/awnrt/automated-firefox/refs/heads/master/ublock_backup.txt"
+
+FILES_DIR="${HOME}/files"
+USERNAME="$(id -nu "1000")"
+
+loginf() {
+ sleep "0.3"
+
+ case "${1}" in
+ g) COL="${G}" MSG="DONE!" ;;
+ r) COL="${R}" MSG="WARNING!" ;;
+ b) COL="${B}" MSG="STARTING." ;;
+ c) COL="${B}" MSG="RUNNING." ;;
+ esac
+
+ TSK="${W}(${C}${TSKNO}${P}/${C}${ALLTSK}${W})"
+ RAWMSG="${2}"
+
+ DATE="$(date "+%Y-%m-%d ${C}/${P} %H:%M:%S")"
+
+ LOG="${C}[${P}${DATE}${C}] ${Y}>>>${COL}${MSG}${Y}<<< ${TSK} - ${COL}${RAWMSG}${N}"
+
+ [ "${1}" = "c" ] && echo -e "\n\n${LOG}" || echo -e "${LOG}"
+}
+
+handle_err() {
+ stat="${?}"
+ cmd="${BASH_COMMAND}"
+ line="${LINENO}"
+ loginf r "Line ${B}${line}${R}: cmd ${B}'${cmd}'${R} exited with ${B}\"${stat}\""
+}
+
+declare -A associate_files
+
+associate_f() {
+ key="${1}"
+ url="${2}"
+ base_path="${3}"
+
+ final_path="${base_path}/${key}"
+
+ associate_files["${key}"]="${url} ${FILES_DIR}/${key} ${final_path}"
+}
+
+update_associations() {
+ associate_f "user.js" "${URL_USER_JS}" "${LIBREW_PROF_DIR}"
+ associate_f "updater.sh" "${URL_UPDATER_SH}" "${LIBREW_PROF_DIR}"
+ associate_f "user-overrides.js" "${URL_USER_OVERRIDES_JS}" "${LIBREW_PROF_DIR}"
+ associate_f "userChrome.css" "${URL_USERCHROME_CSS}" "${LIBREW_CHROME_DIR}"
+ associate_f "userContent.css" "${URL_USERCONTENT_CSS}" "${LIBREW_CHROME_DIR}"
+ associate_f "ublock_backup.txt" "${URL_UBLOCK_BACKUP}" "${HOME}"
+}
+
+update_associations
+
+move_file() {
+ local key="${1}"
+ #local custom_destination="${2:-}"
+ local download_path final_destination
+ IFS=' ' read -r _ download_path final_destination <<< "${associate_files[${key}]}"
+
+ mv -fv "${download_path}" "${final_destination}"
+}
+
+progs() {
+ pct="$((100 * ${2} / ${1}))"
+ fll="$((65 * pct / 100))"
+ bar=""
+ for _ in $(seq "1" "${fll}"); do bar="${bar}${G}#${N}"; done
+ for _ in $(seq "$((fll + 1))" "65"); do bar="${bar}${R}-${N}"; done
+ printf "${bar}${P} ${pct}%%${N}\r"
+}
+
+download_file() {
+ local source="${1}"
+ local dest="${2}"
+
+ [ -f "${dest}" ] && {
+ loginf b "File ${dest} already exists, skipping download."
+ return
+ }
+
+ curl -fSLk "${source}" -o "${dest}" > "/dev/null" 2>&1
+}
+
+retrieve_files() {
+ rm -rfv "${FILES_DIR}" "${HOME}/ublock_backup.txt"
+ mkdir -p "${FILES_DIR}"
+ local total="$((${#associate_files[@]}))"
+ local current="0"
+
+ for key in "${!associate_files[@]}"; do
+ current="$((current + 1))"
+ progs "${total}" "${current}"
+
+ IFS=' ' read -r source dest _ <<< "${associate_files[${key}]}"
+ download_file "${source}" "${dest}"
+ done
+
+ echo ""
+}
+
+create_profile() {
+ rm -rfv "${HOME}/.librewolf"
+ librewolf --headless > "/dev/null" 2>&1 &
+ sleep "3"
+
+ killall "librewolf"
+}
+
+initiate_vars() {
+ LIBREW_CONFIG_DIR="${HOME}/.librewolf"
+
+ LIBREW_PROF_NAME="$(sed -n "/Default=.*\(esr\|release\)$/ { s/Default=//p; q }" \
+ "${LIBREW_CONFIG_DIR}/profiles.ini")"
+
+ LIBREW_PROF_DIR="${LIBREW_CONFIG_DIR}/${LIBREW_PROF_NAME}"
+ LIBREW_CHROME_DIR="${LIBREW_PROF_DIR}/chrome"
+
+ mkdir -pv "${LIBREW_CHROME_DIR}"
+
+ update_associations
+}
+
+place_files() {
+ move_file "user.js"
+ move_file "user-overrides.js"
+ move_file "updater.sh"
+ move_file "userChrome.css"
+ move_file "userContent.css"
+}
+
+modify_orides() {
+ sed -i "s|/home/.*/downloads|/home/${USERNAME}/downloads|
+ s/Count.*/Count\", $(nproc);/" \
+ "${LIBREW_PROF_DIR}/user-overrides.js"
+}
+
+run_arkenfox() {
+ chmod +x "${LIBREW_PROF_DIR}/updater.sh"
+ doas chown -R "1000":"1000" "${HOME}"
+
+ "${LIBREW_PROF_DIR}/updater.sh" -s -u
+}
+
+install_extensions() {
+ EXT_DIR="${LIBREW_PROF_DIR}/extensions"
+ mkdir -pv "${EXT_DIR}"
+
+ ADDON_NAMES=("ublock-origin" "violentmonkey" "darkreader" "vimium-ff")
+
+ for ADDON_NAME in "${ADDON_NAMES[@]}"; do
+ ADDON_URL="$(curl -fSk "https://addons.mozilla.org/en-US/firefox/addon/${ADDON_NAME}/" |
+ grep -o 'https://addons.mozilla.org/firefox/downloads/file/[^"]*')"
+
+ curl -fSLk "${ADDON_URL}" -o "extension.xpi"
+
+ EXT_ID="$(unzip -p "extension.xpi" "manifest.json" | grep "\"id\"")"
+ EXT_ID="${EXT_ID%\"*}"
+ EXT_ID="${EXT_ID##*\"}"
+
+ mv -fv "extension.xpi" "${EXT_DIR}/${EXT_ID}.xpi"
+ done
+}
+
+place_ublock_backup() {
+ move_file "ublock_backup.txt"
+ rm -rfv "${HOME}/files"
+}
+
+main() {
+ declare -A tsks
+ tsks["retrieve_files"]="Retrieve the files.
+ Files retrieved."
+
+ tsks["create_profile"]="Create a profile.
+ A profile created."
+
+ tsks["initiate_vars"]="Initiate new variables.
+ New variabeles initiated."
+
+ tsks["place_files"]="Place the necessary files.
+ The necessary files placed."
+
+ tsks["modify_orides"]="Modify overrides.
+ Overrides modified."
+
+ tsks["run_arkenfox"]="Run the ArkenFox script.
+ The Arkenfox script successful."
+
+ tsks["install_extensions"]="Install browser extensions.
+ Browser extensions installed."
+
+ tsks["place_ublock_backup"]="Place uBlock Backup.
+ uBlock Backup placed."
+
+ tsk_ord=("retrieve_files" "create_profile" "initiate_vars" "place_files" "modify_orides"
+ "run_arkenfox" "install_extensions" "place_ublock_backup")
+
+ ALLTSK="${#tsks[@]}"
+ TSKNO="1"
+
+ trap 'handle_err' ERR RETURN
+
+ for funct in "${tsk_ord[@]}"; do
+ descript="${tsks[${funct}]}"
+ descript="${descript%%$'\n'*}"
+
+ msgdone="$(echo "${tsks[${funct}]}" | tail -n "1" | sed 's/^[[:space:]]*//g')"
+
+ loginf b "${descript}"
+
+ "${funct}"
+ loginf g "${msgdone}"
+
+ [[ "${TSKNO}" -eq "${ALLTSK}" ]] && {
+ loginf g "All tsks completed."
+ kill "0" > "/dev/null"
+ }
+
+ ((TSKNO++))
+ done
+}
+
+main
diff --git a/ublock_backup.txt b/ublock_backup.txt
@@ -0,0 +1,44 @@
+{
+ "timeStamp": 1722992808555,
+ "version": "1.59.0",
+ "userSettings": {
+ "advancedUserEnabled": true,
+ "importedLists": [],
+ "popupPanelSections": 31
+ },
+ "selectedFilterLists": [
+ "user-filters",
+ "ublock-filters",
+ "ublock-badware",
+ "ublock-privacy",
+ "ublock-quick-fixes",
+ "ublock-unbreak",
+ "easylist",
+ "easyprivacy",
+ "urlhaus-1",
+ "plowe-0",
+ "fanboy-cookiemonster",
+ "ublock-cookies-easylist",
+ "adguard-cookies",
+ "ublock-cookies-adguard",
+ "easylist-chat",
+ "easylist-newsletters",
+ "easylist-notifications",
+ "easylist-annoyances",
+ "adguard-mobile-app-banners",
+ "adguard-other-annoyances",
+ "adguard-popup-overlays",
+ "adguard-widgets",
+ "ublock-annoyances",
+ "RUS-0"
+ ],
+ "hiddenSettings": {},
+ "whitelist": [
+ "chrome-extension-scheme",
+ "moz-extension-scheme"
+ ],
+ "dynamicFilteringString": "behind-the-scene * * noop\nbehind-the-scene * inline-script noop\nbehind-the-scene * 1p-script noop\nbehind-the-scene * 3p-script noop\nbehind-the-scene * 3p-frame noop\nbehind-the-scene * image noop\nbehind-the-scene * 3p noop",
+ "urlFilteringString": "",
+ "hostnameSwitchesString": "no-large-media: behind-the-scene false\nno-csp-reports: * true",
+ "userFilters": "||accounts.google.com/gsi/*$xhr,script,3p"
+}
diff --git a/user-overrides.js b/user-overrides.js
@@ -0,0 +1,60 @@
+// Hardware acceleration
+user_pref("media.ffmpeg.vaapi.enabled", true);
+
+// Disable speech recognition warning
+user_pref("media.webspeech.synth.enabled", false);
+
+// Permissions, Privacy and Cookies
+user_pref("media.eme.enabled", false);
+user_pref("permissions.default.desktop-notification", 2);
+user_pref("permissions.default.camera", 2);
+user_pref("permissions.default.geo", 2);
+user_pref("permissions.default.microphone", 2);
+user_pref("cookiebanners.service.mode", 1);
+user_pref("cookiebanners.service.mode.privateBrowsing", 1);
+user_pref("cookiebanners.service.enableGlobalRules", true);
+
+// Black about:blank page
+user_pref("browser.display.background_color.dark", "#353C4A");
+
+// CleanUI
+user_pref("extensions.pocket.enabled", false);
+user_pref("browser.tabs.tabmanager.enabled", false);
+user_pref("identity.fxaccounts.enabled", false);
+user_pref("browser.preferences.moreFromMozilla", false);
+user_pref("toolkit.legacyUserProfileCustomizations.stylesheets", true);
+//user_pref("browser.compactmode.show", true);
+//user_pref("browser.uidensity", 1);
+user_pref("browser.urlbar.suggest.bookmark", false);
+user_pref("browser.urlbar.suggest.history", false);
+user_pref("browser.urlbar.suggest.engines", false);
+user_pref("browser.urlbar.suggest.openpage", false);
+user_pref("browser.urlbar.suggest.topsites", false);
+user_pref("browser.urlbar.autoFill", false);
+user_pref("browser.urlbar.suggest.addons", false);
+user_pref("browser.urlbar.suggest.mdn", false);
+user_pref("browser.urlbar.suggest.recentsearches", false);
+user_pref("browser.translations.automaticallyPopup", false);
+user_pref("signon.firefoxRelay.feature", "disabled");
+user_pref("signon.rememberSignons", false);
+user_pref("signon.management.page.breach-alerts.enabled", false);
+user_pref("signon.generation.enabled", false);
+user_pref("sidebar.revamp", true);
+user_pref("sidebar.verticalTabs", true);
+
+// Smoothfox
+user_pref("general.autoScroll", true);
+user_pref("mousewheel.min_line_scroll_amount", 10); // 10-40; adjust this number to your liking; default=5
+user_pref("general.smoothScroll.mouseWheel.durationMinMS", 80); // default=50
+user_pref("apz.overscroll.enabled", true); // DEFAULT NON-LINUX
+user_pref("general.smoothScroll", true); // DEFAULT
+user_pref("general.smoothScroll.msdPhysics.continuousMotionMaxDeltaMS", 12);
+user_pref("general.smoothScroll.msdPhysics.enabled", true);
+user_pref("general.smoothScroll.msdPhysics.motionBeginSpringConstant", 600);
+user_pref("general.smoothScroll.msdPhysics.regularSpringConstant", 650);
+user_pref("general.smoothScroll.msdPhysics.slowdownMinDeltaMS", 25);
+user_pref("general.smoothScroll.msdPhysics.slowdownMinDeltaRatio", "2.0");
+user_pref("general.smoothScroll.msdPhysics.slowdownSpringConstant", 250);
+user_pref("general.smoothScroll.currentVelocityWeighting", "1.0");
+user_pref("general.smoothScroll.stopDecelerationWeighting", "1.0");
+user_pref("mousewheel.default.delta_multiplier_y", 400); // 250-400; adjust this number to your liking
diff --git a/userChrome.css b/userChrome.css
@@ -0,0 +1,36 @@
+@-moz-document url(chrome://browser/content/browser.xhtml)
+{
+ #main-window,
+ browser[type="content-primary"],
+ browser[type="content"],
+ tabbrowser#content,
+ #content,
+ browser[type="content"] > html
+ {
+ /*gruvbox*/
+ /*background: #32302f !important;*/
+ background: #353C4A !important;
+ }
+}
+
+#reload-button { display: none !important; }
+#back-button { display: none !important; }
+#forward-button { display: none !important; }
+#sidebar-button { display: none !important; }
+#firefox-view-button { display: none !important; }
+#new-tab-button { display: none !important; }
+#alltabs-button { display: none !important; }
+#stop-button { display: none !important; }
+#identity-permission-box { display: none !important; }
+#picture-in-picture-button { display: none !important; }
+#tracking-protection-icon-container { display: none !important; }
+#star-button-box { display: none !important; }
+#pageAction-urlbar-_testpilot-containers { display: none !important; }
+#navigator-toolbox > #PersonalToolbar { display: none !important; }
+#tabbrowser-tabbox {
+ outline: none !important;
+ box-shadow: none !important;
+
+}
+#reader-mode-button { display: none !important; }
+#translations-button { display: none !important; }
diff --git a/userContent.css b/userContent.css
@@ -0,0 +1,17 @@
+@-moz-document url(aboutnewtab) {
+ body {
+ background-color #353C4A !important;
+ }
+}
+
+@-moz-document url(aboutblank) {
+ body {
+ background-color #353C4A !important;
+ }
+}
+
+@-moz-document url(chromebrowsercontentbrowser.xhtml) {
+ browser[type=content-primary] {
+ background #353C4A !important
+ }
+}